//
// 	display_panel.h
//

class display_panel : public generic_window
{
	Frame frame;

	display_frame* parent_frame;	// parent frame
	display_window* parent_window;	// parent window	

	int item_total;			// item total
	panel_type_list* item_list; 	// item list

// data panel
	Scrollable_panel data_panel;

//	int data_item_total;			// item total
//	panel_type_list* data_item_list; 	// item list

	int data_item_x_loc, data_item_y_loc; 	// data item location
// main panel
	Panel main_panel;

	int main_item_total;			// main item total
//	panel_type_list* main_item_list; 	// main item list

	int main_item_x_loc, main_item_y_loc; 	// main item location
public:
		display_panel(display_frame*,display_window*,char*);
		~display_panel();

	Frame	get_frame() { return frame; }
	Panel	get_main_panel() { return main_panel; }
	Scrollable_panel	get_data_panel() { return data_panel; }

	int 	get_item_total() { return item_total; }
	panel_type_list* get_item_list() { return item_list; }

//	int 	get_data_item_total() { return data_item_total; }
//	panel_type_list* get_data_item_list() { return data_item_list; }

	int 	get_main_item_total() { return main_item_total; }
//	panel_type_list* get_main_item_list() { return main_item_list; }

	panel_object* get_panel_item(int);
	panel_object* get_panel_item(char*);

// resize panel
	void	resize(int,int,int,int);
// init panel items
	void 	reset();
	void 	init();
	void 	reset_main();
	void 	init_main();
	void 	reset_data();
	void 	init_data();
	void 	reset_data_list();
// re-init panel entries (w/o creating objects)
	void 	init_items();
// create canvas 
	void 	create();
	void	create(int,int,int,int);
// clear panel
	void	clear();
// data items
	void 	init_button_entry(char*);
	void 	init_data_entry(char*);
	void 	init_data_menu_entry(char*,int);
	void 	init_message_entry(char*);
// gen items 0 - data, 1 - main (last arg)
	void 	init_button_entry(char*,int);
	void 	init_data_entry(char*,int);
	void 	init_data_menu_entry(char*,int,int);
	void 	init_message_entry(char*,int );

// read from database and display
	void 	update();
	void 	update(char*);
	void	display();
	void	display(char*);
	void	read_from_database();
	void	write_to_database();
	void	read_from_database(char*);
	void	write_to_database(char*);

	void 	init_scroll_bar();
// print items
	void	print_status(ostream&);
	void	print_all_item_status(ostream&);
	void	print_item_status(ostream&,int);
	void	print_item_status(ostream&,char*);
};
