//
//	nsl_diff.h
//

struct nsl_diff
{
	char name[NAME_SIZE];
	int type; 		// 1 - EULER
	nsl_layer* layer; 	// layer pointer
	int layer_type;		// 1 - data, 2 - vector, 3 - matrix
	float dt;		// time step
	float tm;		// time constant

public:
		nsl_diff();
		~nsl_diff();
// set
	void 	set_name(char* str) { strcpy(name,str); }
	void 	set_type(int i) { type = i; }
// get
	char* 	get_name() { return name; }
	int 	get_type() { return type; }

// 	assignment
	void 	operator=(nsl_matrix&);
	void 	operator=(nsl_vector&);
	void 	operator=(nsl_data&);
	void 	operator=(num_type);

	nsl_diff& eq(nsl_data&,num_type);
	nsl_diff& eq(nsl_vector&,num_type);
	nsl_diff& eq(nsl_matrix&,num_type);

	nsl_diff& eq(nsl_data&,nsl_data&);
	nsl_diff& eq(nsl_vector&,nsl_data&);
	nsl_diff& eq(nsl_matrix&,nsl_data&);
};

typedef nsl_diff NSL_DIFF;


