
/*
 *  file : bp_parms.h
 *
 *    User-defined parameters for backprop.
 *
 */


             /*  Layer parameters.  */

#define NUM_INPUT 2
#define NUM_HIDDEN 2
#define NUM_OUTPUT 1
#define MAX_PATTERNS 100

             /*  Configuration parameters.  */

/*#define REMOVE_HIDDEN_UNITS_FLAG */
/*#define INPUT_TO_OUTPUT_WEIGHTS  */
/* #define LAST_HIDDEN_FLAG */  /* Do not set unless REMOVE_HIDDEN_UNITS_FLAG is not set.  */

/* #define LAST_HIDDEN_TO_OUTPUT_WEIGHTS */
/* #define LINEAR_OUTPUTS */


#define GRADIENT_BIAS_FLAG

/* #define LH_H_WEIGHT_MASK */

/* #define AUTO_PARAMETERS_FLAG  */

#ifdef AUTO_PARAMETERS_FLAG
#define AP_DEFAULT_AUTO_PARAMETERS 1.0
#define AP_DEFAULT_LRATE 0.02
#define AP_DEFAULT_MOMENTUM 0.0
#define AP_DEFAULT_MAX_MOMENTUM 0.95
#define AP_DEFAULT_SETTLE_COUNT 10
#define AP_DEFAULT_PATIENCE_COUNT 40
#define AP_DEFAULT_LRATE_FACTOR 1.2
#define AP_DEFAULT_LRATE_GROWTH_FACTOR 1.1
#define AP_DEFAULT_MOMENTUM_STEP 0.05
#define AP_DEFAULT_MOMENTUM_GAIN 0.05
#define AP_DEFAULT_MAX_DERROR 5.0
#define AP_DEFAULT_UP_TOLERANCE 3.0

              
#endif

             /*  Epoch step determines how often nsl reports back */
             /* what the current epoch and tss are.               */

#define DEFAULT_EPOCH_STEP 1


/*  #define DISPLAY_AUTO_PARAMETERS_DATA */


#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
#define AP_WAIT 1.0  /*  Do not change these.  */
#define AP_RUN 2.0


