/****************************************************************/
/*                                                           	*/
/*                       dev.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(DEV);

MATRIX(S,10,8);		// network input 
MATRIX(u,10,8); 	
MATRIX(U,10,8); 	

VECTOR(v,8); 	
VECTOR(V,8); 	

VECTOR(W1,5);

DATA(k);
DATA(tm);

INIT_MODULE(dev_init)
{
	u = -0.5;
	U = 0;
	v = 0;
	V = 0;
}

RUN_MODULE(dev_U_run)
{
	DIFF.eq(u,tm) = - u + W1*U - NSLrow_vec_to_mat(V,10) + S - 0.7;
	U = NSLstep(u,k);
}
RUN_MODULE(dev_V_run)
{
	DIFF.eq(v,tm) = - v + NSLmat_to_row_vec(U) - 0.7;
	V = NSLramp(v);
}



