/****************************************************************/
/*                                                           	*/
/*                       tutorial.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(TUTORIAL);

VECTOR(INP,10);	// network input 
VECTOR(A,10); 	// layer
VECTOR(B,10); 	// layer
VECTOR(S,10); 	// temp layer

VECTOR(M,3); 	// mask

INIT_MODULE(tutorial_init)
{
	M.elem(0) = 1; 		// initialize mask
	INP.elem(0) = 1;	// initialize input

	A = 0;			// reset layer
	S = 0;			// reset layer
	B = 0;			// reset layer
}
RUN_MODULE(tutorial_A_run)
{
	A = M*B + INP;		// convolution with B
	INP = 0;		// reset input after initial setting
}
RUN_MODULE(tutorial_B_run)
{
	B = S;			// simulate parallelism
	S = A;			// assign A
}

