//
//	display_graph.c
//

# include "nsl.h"
# include "nsl_headers.h"
# include "nsl_winds.h"

// display graph

display_graph::display_graph(display_window* window,char* str) 
	: (window,"",str,0)
{
	wx0 = 0;
	wy0 = 0;
	wx1 = 0;
	wy1 = 0;
	wxs = 0;
	wys = 0;

	wxmin = 0;
	wymin = 0;
	wxmax = 0;
	wymax = 0;
}
display_graph::~display_graph()
{
}

void display_graph::read_from_database()
{
	parent_window->get_general_data("wx0",&wx0);
	parent_window->get_general_data("wx1",&wx1);
	parent_window->get_general_data("wy0",&wy0);
	parent_window->get_general_data("wy1",&wy1);
	parent_window->get_general_data("wxs",&wxs);
	parent_window->get_general_data("wys",&wys);

//	parent_window->get_general_data("wxmin",&wxmin);
//	parent_window->get_general_data("wxmax",&wxmax);
	parent_window->get_general_data("wymin",&wymin);
	parent_window->get_general_data("wymax",&wymax);

	if (wymax <= wymin)
	{
		wymin = 0.0;
		wymax = 1.0;
		parent_window->set_general_data("wymin",wymin);
		parent_window->set_general_data("wymax",wymax);
	}
}
void display_graph::write_to_database()
{
}
void display_graph::print(ostream& out)
{
}


