/**************************************************************/
/*                                                            */
/*                       nsl_interpreter.c                    */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

# include "nsl.h"
# include "nsl_headers.h"

nsl_interpreter NSL;
extern int nsl_shell(istream&);

nsl_interpreter::nsl_interpreter()
{
	buffer = new nsl_buffer;
	stream = (istream*) buffer->get_stream();
}
nsl_interpreter::~nsl_interpreter()
{
}
nsl_interpreter& nsl_interpreter::operator<<(istream& in)
{
	status = nsl_shell(in);

	return (*this);
}
nsl_interpreter& nsl_interpreter::operator<<(char* str)
{
	(*buffer) << str;

	if (strcmp(str,"\n") == 0)
		status = nsl_shell(*stream);

	return (*this);
}
nsl_interpreter& nsl_interpreter::operator<<(int val)
{
	(*buffer) << val;

//	status = nsl_shell(*stream);

	return (*this);
}
nsl_interpreter& nsl_interpreter::operator<<(float val)
{
	(*buffer) << val;

//	status = nsl_shell(*stream);

	return (*this);
}

