//<IMG SRC="/HBP/pics/hr/USCBar_thin_half.gif" ALT="-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-">
//  CEREBELLUM CONDITIONING MODEL
//  Originally a model of the role of the cerebellum in <A HREF="/HBP/models/conformant/Dart_1.1/dart_main.html">dart throwing</A>
//  <A HREF="/HBP/models/conformant/Dart_1.1/dart_main.html">adaptation</A> by Nicolas Schweighofer (<A HREF="../abstracts/arbib94.html">Arbib, Schweighofer and Thach 1994</A>).
//  Adapted for Classical Conditioning paradigm by the cerebellum group. 
//  Address any <A HREF="/HBP/Forms/mailit.html">questions or comments to Brain Models on the Web at USC</A>
//<IMG SRC="/HBP/pics/hr/USCBar_thin_half.gif" ALT="-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-">

//<B>Contents:</B>
//<IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#MAIN_INIT">Initializations</A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#TRIAL_INIT">Classical Conditioning Trial parameters</A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#MF_INIT"><B>Mossy Fibers:</B><I> Input the Tone.</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#GC_INIT"><B>Granule cells:</B><I> parameters.</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#WEIGHT_INIT"><B>Modifiable weights</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#SYNAPSE_INIT"><B>Synapse and PKC2 messenger system</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#PC_INIT"><B>Purkinje cells:</B><I> parameters.</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#GC_INIT"><B>Granule cells:</B><I> parameters.</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#IO_INIT"><B>Inferior Olive:</B><I> parameters.</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#TAU_INIT"><B>Time constants</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#ELIGIBILITY_INIT"><B>Eligibility parameters</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#LEARNING_INIT"><B>Learning coefficients</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#SIGMOID_INIT"><B>Sigmoid specifications</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#ELECTRODE_INIT"><B>Recorded neurons.</B></A>

//<IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#MAIN_MOD">Simulation Run Modules</A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#INIT_MOD"><B>Module which initializes the simulation</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#ELECTRODE_MOD"><B>Recording Electrode Run Module</B></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#AUDITORY_MOD"><B>Auditory Input Run Module:</B> <I>Tone CS</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#IO_MOD"><B>Inferior Olive Run Module:</B> <I>Air Puff US</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#GC_MOD"><B>Granule Cell Run Module:</B> <I>Context</I></A>
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#PC_MOD"><B>Purkinje Cell Run Module:</B> <I>Only Cerebellar Output</I></A>	
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#IP_MOD"><B>Interpositus Nucleus Run Module:</B> <I>CR Response</I></A>	
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#ELIGIBILITY_MOD"><B>Synaptic Eligibility Run Module:</B> <I>Synaptic Timing</I></A>	
//<IMG SRC="/HBP/pics/space/Space30.gif" WIDTH=30 HEIGHT=1><IMG SRC="/HBP/pics/bullets/USCBullet.gif" WIDTH=18 HEIGHT=10><A HREF="#LEARNING_MOD"><B>Learning Rule Run Module:</B> <I>Synaptic LTP/LTD</I></A>
//<IMG SRC="/HBP/pics/hr/USCBar_thin_half.gif" ALT="-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-">

#include "nsl_include.h"
#include "math.h"

#define TONEMF 10		// numbers of cells of each type.
#define BOUTONOF 30		// 180 in Dart model.
#define GCNUMBEROF 30		// 1000 in dart adaptation.
#define PCNUMBEROF 10
#define DOGOF 9
 

// <A NAME="MAIN_INIT">Initialization</A>
#define SEED 1
	extern 	float ran1(int *);	// random number generator.

	// Gaussian Kernel generation functions.
	extern 	nsl_matrix gaussm(int,int,nsl_data &,nsl_data &, nsl_data &);
	extern 	nsl_vector gaussv(int , nsl_data &,  nsl_data &);


	NETWORK(DART);

	FILE * fopen(), *fpteta;

	int	 seed = SEED;	// random number initialization


// <A NAME="TRIAL_INIT"><B>Classical Conditioning Trial parameters</B></A>

	DATA(TrialLength);	// length of individual trial
	DATA(CS_ON);		// time at which Tone comes on
	DATA(US_ON);		// time at which Airpuff comes on
	DATA(CS_US_OFF);	// time at which Airpuff and Tone co-terminate.
	DATA(tone_baseline);	// tone mossy fibers parameters.
	DATA(tone_max);
	DATA(tone_edge);


//<A NAME="MF_INIT"><B>Mossy Fibers:</B><I> Input the Tone.</I></A>

	VECTOR(tone1mf, TONEMF);  VECTOR(tone2mf, TONEMF); VECTOR(tone3mf, TONEMF);
	VECTOR(bouton, BOUTONOF);


//<A NAME="GC_INIT"><B>Granule cells:</B><I> parameters.</I></A>

	VECTOR(gc, GCNUMBEROF);
	DATA(wmf_gc);
	DATA(gcthresh);
	DATA(gcmax);
	VECTOR(GC, GCNUMBEROF);

//<A NAME="WEIGHT_INIT"><B>Modifiable weights</B></A>
	MATRIX(wltd, GCNUMBEROF, PCNUMBEROF);
	DATA(w_ini_width);
	DATA(w_ini_mean);
	DATA(wthresh);
	

//<A NAME="SYNAPSE_INIT"><B>Synapse and PKC2 messenger system</B></A>

		
	//pkc2 messengers:two 1st order equa diffs make one 2 nd order
	MATRIX(Hebb, GCNUMBEROF, PCNUMBEROF);
	MATRIX(pkc1, GCNUMBEROF, PCNUMBEROF);
	MATRIX(pkc2, GCNUMBEROF, PCNUMBEROF);
	MATRIX(PKC, GCNUMBEROF, PCNUMBEROF);	//plus step


//<A NAME="PC_INIT"><B>Purkinje cells:</B><I> parameters.</I></A>
	VECTOR(auxp, PCNUMBEROF);
	VECTOR(pc, PCNUMBEROF);
	VECTOR(PC, PCNUMBEROF);		


//<A NAME="GC_INIT"><B>Granule cells:</B><I> parameters.</I></A>
	//nuclear noise and weights
	DATA(B);
	DATA(i_nu);

	VECTOR(nuc, PCNUMBEROF);
	VECTOR(NUC, PCNUMBEROF);
	VECTOR(wpc_nu,5);
	DATA(alpha_nu);
	DATA(sigma_nu);
	DATA(nucx);
	DATA(nucy);
	DATA(wCS_nuc);				// CS influence on the Nucleus.
						// NOT IN DART MODEL.

//<A NAME="IO_INIT"><B>Inferior Olive:</B><I> parameters.</I></A>
	VECTOR(CF,PCNUMBEROF);
	DATA(io);
 

//<A NAME="TAU_INIT"><B>Time constants</B></A>
	DATA(gc_tau);
	DATA(pc_tau);
	DATA(nuc_tau);
	DATA(io_tau);
		

//<A NAME="ELIGIBILITY_INIT"><B>Eligibility parameters</B></A>
	DATA(tau2);
	DATA(tau3);
	DATA(K);
	DATA(thresh);
	DATA(val);

//<A NAME="LEARNING_INIT"><B>Learning coefficients</B></A>
	DATA(a);  DATA(b);

//<A NAME="SIGMOID_INIT"><B>Sigmoid specifications</B></A>
	DATA(kx2);  DATA(ky2);


//<A NAME="ELECTRODE_INIT"><B>Recorded neurons.</B></A>
	DATA(mf_show);
	DATA(gc_show);
	DATA(pc_show);
	DATA(nuc_show);
	DATA(CF_show);
	DATA(response_show);


	DATA(cblm_time);
	float t, time_temp;

//<A NAME="MAIN_MOD"><B>Simulation Run Modules</B></A>
//<A NAME="INIT_MOD"><B>Module which initializes the simulation</B></A>
INIT_MODULE(ini){
	
	gc = 0;GC = 0;
	pc = 0;PC = 0;
	nuc = 0;NUC = 0;
	pkc1 = 0;pkc2 = 0; PKC = 0;

// 	<B>generation of the different masks</B>

		
	for (int i = 0; i < GCNUMBEROF; i++) {		
		for (int j = 0; j < PCNUMBEROF; j++) {
		
			wltd.elem(i, j) = w_ini_width.elem() * (ran1(&seed) - .5) 
			             + w_ini_mean.elem();
		}
	}



	//wpc_nu = gaussv(5, alpha_nu, sigma_nu);	// stored in condit.nsl
	

}

//<A NAME="ELECTRODE_MOD"><B>Recording Electrode Run Module</B></A>
RUN_MODULE(Record_electrode){
					// electrode is placed on x = 5.
	mf_show = tone1mf.elem(5);
	gc_show = gc.elem(5);
	pc_show = pc.elem(5);
	nuc_show = nuc.elem(5);
	CF_show = CF.elem(5);
}

//<A NAME="AUDITORY_MOD"><B>Auditory Input Run Module:</B> <I>Tone CS</I></A>
RUN_MODULE(Auditory_Input) {
	
	t = DART.get_time();
	cblm_time.elem() = floor(t);
	time_temp = cblm_time.elem();
	
	if ( (t > CS_ON.elem() + time_temp) && (t < CS_ON.elem() + tone_edge.elem() + time_temp) )
		tone1mf = tone_max;
	else  tone1mf = tone_baseline;
}

//<A NAME="IO_MOD"><B>Inferior Olive Run Module:</B> <I>Air Puff US</I></A>
RUN_MODULE(IO) { 	
	
	/* Turn all climbing fibers on after air puff */
	if ( (t > US_ON.elem() + time_temp) && (t < CS_US_OFF.elem() + time_temp ) )
		CF = 1;
	else  CF = 0;	
}

//<A NAME="GC_MOD"><B>Granule Cell Run Module:</B> <I>Context</I></A>
RUN_MODULE(GRANULLE_CELLS) {

	
	int count = 0;			// very much simplified from Dart model
		
	for (int k =0; k< TONEMF; k++) {

		bouton.elem(k) = tone1mf.elem(k);
		//bouton.elem(k) = tone2mf.elem(k);	//different tone info.
		//bouton.elem(k) = tone3mf.elem(k);
	}

						 
	DIFF.eq(gc, gc_tau) = -gc + wmf_gc * bouton;	
	GC = NSLstep(gc,gcthresh.elem(),0,gcmax.elem());
}

//<A NAME="PC_MOD"><B>Purkinje Cell Run Module:</B> <I>Only Cerebellar Output</I></A>		
RUN_MODULE(PURKINJE) {
// Purkinje cell activity

	auxp = 0;
	
	for (int n = 0; n < PCNUMBEROF; n++){
			for (int m = 0; m < GCNUMBEROF; m++){

			auxp.elem(n) =  auxp.elem(n) + wltd.elem(m,n)*GC.elem(m) * 1.5;				//1.5 not in Dart model
		}
	}
		
	DIFF.eq(pc, pc_tau) = -pc + auxp + 50;			//50 not in Nico
	PC = NSLsaturation(pc,0,kx2.elem(),0,ky2.elem());
}			
	
//<A NAME="IP_MOD"><B>Interpositus Nucleus Run Module:</B> <I>CR Response</I></A>
RUN_MODULE(NUCLEUS) {


	// introduce influence of CS on the nuc.; not in Dart model.

	DIFF.eq(nuc, nuc_tau) = -nuc - NSLconv_copy(wpc_nu,PC) + B + wCS_nuc * tone1mf;

	NUC = NSLsaturation(nuc,0,nucx.elem(),0,nucy.elem());
}
	
//<A NAME="ELIGIBILITY_MOD"><B>Synaptic Eligibility Run Module:</B> <I>Synaptic Timing</I></A>
RUN_MODULE(eligibility) {
//1st equation of 2nd messenger activated by coactivation of gc and PCs

	for (int n = 0; n < GCNUMBEROF; n++){
		for (int m = 0; m < int(PCNUMBEROF); m++){
			Hebb.elem(n,m) = GC.elem(n)*PC.elem(m);
		}
	}
		
	DIFF.eq(pkc1, tau2) = -pkc1 + K.elem() * Hebb;

	//2nd messenger 2nd equation

	DIFF.eq(pkc2, tau3) = -pkc2 + pkc1;
	PKC = NSLramp(pkc2, thresh.elem());
	
}
	
//<A NAME="LEARNING_MOD"><B>Learning Rule Run Module:</B> <I>Synaptic LTP/LTD</I></A>
RUN_MODULE(learning_rule) {	

	for (int k = 0; k < PCNUMBEROF; k++){
	
		for (int m = 0; m < GCNUMBEROF; m++){

			wltd.elem(m,k) = wltd.elem(m,k) - a.elem()*CF.elem(k)*PKC.elem(m,k)
				    + b.elem()*(1 - CF.elem(k))*PKC.elem(m,k);
		}
	}

	wltd = NSLsaturation(wltd, 0 , wthresh.elem(), 0, wthresh.elem());

}


