/**************************************************************/
/*                                                            */
/*                   nsl_command_buffer.h                     */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

class command_buffer
{
// data type: 1 - int, 2 - float, 3 - char*
	data_type_list* data_list;
	int data_total;

// file
	int file_type; // = 2;
	int file_index; // = 0;
	string file_type_name;
	string file_name;
 	int file_auto_name_fg; // = ON;

// window dumps
	int dump_type; // 1;
  	string dump_file; // file name
   	string dump_type_name; // printer
   	int dump_ras_index; // 0;
 	int dump_ps_index; // 0;
 	int dump_auto_name_fg; // ON;
public:
		command_buffer();
		~command_buffer();

// layer
	void	set_layer_data_value(istream&,nsl_layer*);
	void	set_layer_elem_data_value(istream&,nsl_layer*,int,int);
	void	set_layer_all_data_value(istream&,nsl_layer*);
// update
	void	update_layer_buffer(char*);
	void 	update_graph_buffer(char*);
// init database entry
	int	init_general_data(char*,int);  
// set database entry value
	int	set_general_data(char*,char*);
	int	set_general_data(char*,float);
	int	set_general_data(char*,int);
	int	set_on_off_data(char*,int);
// get database entry value
	int	get_general_data(char*,char*);
	int	get_general_data(char*,float*);
	int	get_general_data(char*,int*);
	int	get_on_off_data(char*);
// get database entry type: 1 - int, 2 - float, 3 - char*
	int	get_general_data_type(char*);
// get data back
	nsl_data* get_data(char*);

	void print(ostream&);
};
