//
// 	panel_item_object.h
//

struct panel_item_obj : public panel_object
{
	Panel_item item;	// sunview handle
	int wx,wy;		// item location
	char label[NAME_SIZE]; 	// item label
	char text[NAME_SIZE]; 	// item label
	int panel_fg;		// 0 - data_panel, 1 - main_panel
public:
		panel_item_obj(display_window*,char*,char*,int);
		~panel_item_obj();

// set
	void	set_item(Panel_item m) { item = m; }
	void	set_label(char* str) { strcpy(label,str); }
	void	set_text(char* str) { strcpy(text,str); }
	void	set_wx(int s) { wx = s; }
	void	set_wy(int s) { wy = s; }
	void	set_panel_fg(int i) { panel_fg = i; }
// get
	Panel_item get_item() { return item; }
	char*	get_label() { return label; }
	char*	get_text() { return text; }
	int	get_wx() { return wx; }
	int	get_wy() { return wy; }
	int 	get_panel_fg() { return panel_fg; }

	virtual	void	init() {}
	virtual	void	write_to_database() {}
	virtual	void	read_from_database() {}
	virtual	void	display() {}
	virtual	void	print(ostream&);
};

struct panel_button_item_obj : public panel_item_obj
{
public:
		panel_button_item_obj(display_window*,char*,int);
		~panel_button_item_obj();

	void	init();
};

struct panel_data_item_obj : public panel_item_obj
{
public:
		panel_data_item_obj(display_window*,char*,int);
		~panel_data_item_obj();

	void	init();

	void	write_to_database();
	void	read_from_database();
	void	display();
};

struct panel_data_menu_item_obj : public panel_item_obj
{
	int menu_index;	// index of menu: 1- LAYER, 2 - GRAPH
	int choice_index; // index of entry choice in menu
public:
		panel_data_menu_item_obj(display_window*,char*,int);
		~panel_data_menu_item_obj();

	void	set_menu_index(int i) { menu_index = i; }
	int	get_menu_index() { return menu_index; }

	void	set_choice_index(int i) { choice_index = i; }
	int	get_choice_index() { return choice_index; }

	void	init();

	void	write_to_database();
	void	read_from_database();
	void	display();
};

struct panel_message_item_obj : public panel_item_obj
{
public:
		panel_message_item_obj(display_window*,char*,int);
		~panel_message_item_obj();

	void	init();

	void	write_to_database();
	void	read_from_database();
	void	display();
};

