//
// 	spatial_graph_2.h
//

struct spatial_graph_2 : public display_graph
{
	int pulsefg;
public:
		spatial_graph_2(display_window*);
// database updates
	virtual	void	read_from_database();
	virtual void	write_to_database();
	virtual void	print(ostream&);
	virtual void	display();
	virtual	void	input(int,int,int);
	virtual	void	output(int,int);
};
class spatial_graph_2_par : public spatial_graph_2
{
public:
		spatial_graph_2_par(display_window*,nsl_data*);
// database updates
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
class spatial_graph_2_vec : public spatial_graph_2
{
	int i0,i1;		// vector range
	int imax;		// vector size
	int vec_type;		// 0 - row, 1 - col
public:
		spatial_graph_2_vec(display_window*,nsl_vector*);
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
class spatial_graph_2_mat : public spatial_graph_2
{
	int i0,i1;		// row range
	int j0,j1;		// col range
	int imax,jmax;		// matrix size
public:
		spatial_graph_2_mat(display_window*,nsl_matrix*);
// database updates
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
