/****************************************************************/
/*                                                           	*/
/*                       stretch.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(STRETCH);

DATA(v); 	
DATA(x); 

DATA(kx);
DATA(ky);
DATA(tm);

INIT_MODULE(stretch_init)
{
	x = 2;
	v = 0;
}

RUN_MODULE(stretch_x_run)
{
	x = x + kx*v;
}
RUN_MODULE(stretch_v_run)
{
	DIFF.eq(v,tm) = -v + ky*x;
}


