/**************************************************************/
/*                                                            */
/*                       nsl_c_functions.c                    */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

# include <signal.h>

extern int BREAKFG;

int interrupt_handler()     /* HANDLER traps interrupt '^C' */
{
        BREAKFG = 1;
      	signal(SIGINT,interrupt_handler);

	return 1;
}
int urgent_handler()     /* HANDLER traps interrupt 'L1' (STOP) */
{
        BREAKFG = 1;
      	signal(SIGURG,urgent_handler);

	return 1;
}
nsl_c_init()
{
	signal(SIGINT,interrupt_handler); 	/* SIGINT '^C' */
/*	signal(SIGURG,urgent_handler); 	*/	/* SIGURG 'L1' (STOP) */
}
